import gtk
import gobject
from DentButton import DentButton
class Dent(gtk.EventBox,gobject.GObject):
	__gsignals__ = {
		'reply-clicked': (
			gobject.SIGNAL_RUN_FIRST, gobject.TYPE_NONE,
						   (gobject.TYPE_STRING,gobject.TYPE_STRING)
			),
		'view-conversation-clicked': (
			gobject.SIGNAL_RUN_FIRST, gobject.TYPE_NONE,
						   (gobject.TYPE_INT,)
			),
		'user-clicked': (
			gobject.SIGNAL_RUN_FIRST, gobject.TYPE_NONE,
						   (gobject.TYPE_STRING,)
			),
		'group-clicked': (
			gobject.SIGNAL_RUN_FIRST, gobject.TYPE_NONE,
						   (gobject.TYPE_STRING,)
			)
	}
	def __init__(self,data,is_conv=False):
		gtk.EventBox.__init__(self)
		#store the passed variables
		self.id = data['status_id']
		self.screen_name = data['screen_name']
		self.in_reply_to_id=data['in_reply_to_id']
		self.in_reply_to_screen_name=data['in_reply_to_screen_name']
		user_box = gtk.HBox(False,0)
		user_box.set_border_width(5)
		self.image = gtk.Image()
		user_box.pack_start(self.image,False,False,0)
		vbox = gtk.VBox(False,0)
		#vbox.set_border_width(5)
		user_box.pack_start(vbox,False,False,0)
		text_label = gtk.Label()		
		text_label.set_markup( data['markup'] )
		text_label.set_alignment(0,0)
		text_label.set_line_wrap(True)
		text_label.set_selectable(True)
		#unset this things focus
		text_label.unset_flags(gtk.CAN_FOCUS)
		text_label.set_justify(gtk.JUSTIFY_LEFT)
		
		name_label = gtk.Label()
		name_label.set_markup("<b>%s</b>" % (self.screen_name))
		self.name_event_box = gtk.EventBox()
		self.name_event_box.add(name_label)
		#connect some signals to the event box
		self.name_event_box.connect("button-press-event", self.name_label_clicked,self.screen_name )
		self.name_event_box.connect("realize",self.neb_realized)
		#visited links may not work on some systems ( like my N810 )
		try:
			text_label.connect("activate-link", self.process_link )
			text_label.set_track_visited_links(False)
		except:
			#nothing to do
			pass
		#make the time label
		time_label = gtk.Label()
		time_label.set_markup(" <span size='x-small'> %s</span>" % (data['time']) )
		#make an hbox for the name_button
		hbox = gtk.HBox(False,0)
		hbox.pack_start(self.name_event_box,False,False,0)
		hbox.pack_start(time_label,False,False,0)
		vbox.pack_start(hbox,False,False,0)
		vbox.pack_start(text_label,False,False,0)
		#add a "reply" button
		reply_button = DentButton('reply')
		reply_button.connect("clicked",self.reply_clicked)
		hbox = gtk.HBox(False,0)
		hbox.pack_start(reply_button,False,False,0)
		#if there is a in reply to conversation happening
		if self.in_reply_to_screen_name!=None:
			reply_to_button = DentButton('context')
			reply_to_button.connect("clicked",self.view_conv_clicked)
			hbox.pack_start(reply_to_button,False,False,0)
		
		vbox.pack_start(hbox,False,False,0)
		self.add(user_box)
	
	def neb_realized(self,widget):
		hand2 = gtk.gdk.Cursor(gtk.gdk.HAND2)
		widget.window.set_cursor(hand2)
	
	def name_label_clicked(self,widget,event,name):
		self.emit('user-clicked',name)
	
	def reply_clicked(self,button):
		self.emit("reply-clicked",self.id,self.screen_name)

	def view_conv_clicked(self,button):
		self.emit("view-conversation-clicked",self.id)
		
	def set_image(self,image_path):
		self.image.set_from_file(image_path)
		
	def process_link(self, label, uri ):
		if uri[0]=="@":
			screen_name=uri.lstrip("@")
			self.emit('user-clicked',screen_name)
			#since we are processing the uri return true
			return True
		elif uri[0]=="!":
			group_name=uri.lstrip("!")
			self.emit('group-clicked',group_name)
			#since we are processing the uri return true
			return True
			
			
			
			
