import gtk
#this might be on Maemo
try:
	import hildon
	has_hildon = True
except:
	has_hildon = False
	
#what is the max number of dents we want to keep track of?
MAX_DENTS=50
class DentScroller(gtk.ScrolledWindow):
	def __init__(self):
		self.scrollable=False
		#keep track of this dentscroller's ids
		self.ids = []
		gtk.ScrolledWindow.__init__(self)
		#are we on Maemo?
		if has_hildon:
			hildon.hildon_helper_set_thumb_scrollbar(self, True)
		self.set_policy(gtk.POLICY_AUTOMATIC,gtk.POLICY_AUTOMATIC)
		self.dent_scroll_vbox=gtk.VBox(spacing=1)
		self.viewport = gtk.Viewport()
		self.viewport.add(self.dent_scroll_vbox)
		try:
			self.viewport.modify_bg(gtk.STATE_NORMAL,gtk.gdk.Color('#666') )
		except:
			#what the hell version of python-gtk is this?
			pass
		self.add(self.viewport)
		#pack an empty label to the end of this vbox
		self.dent_scroll_vbox.pack_end(gtk.Label("") )
		#connect some events
		''' TODO: make scrolling available for the Maemo
		self.connect('button-press-event', self.button_press )
		self.connect('button-release-event', self.button_release )
		self.connect('motion-notify-event', self.motion_notify )
		self.viewport.connect('leave-notify-event', self.leave_notify )
		'''
		
	def add_dent(self,dent,is_conv=False):
		#is this id already in this scroller?
		dent_id = dent.id
		if not dent_id in self.ids:
			self.ids.append(dent_id)
			if is_conv:
				self.dent_scroll_vbox.pack_start(dent,False,False,0)
			else:
				self.dent_scroll_vbox.pack_end(dent,False,False,0)
			#hey! how many children does the self.dent_scroll_vbox have?
			children=self.dent_scroll_vbox.get_children()
			while len(children)>MAX_DENTS:
				self.dent_scroll_vbox.remove( children[-1] )
				d = children.pop()
				try:
					self.ids.remove(d.id)
				except:
					pass
			#it would be nice to see this dent
			dent.show_all()

	def button_press(self,widget,e):
		print "begin"
		self.start_y = e.y
		self.initial_bar_y = self.get_vscrollbar().get_value()
		self.scrollable=True

	def button_release(self,widget,e):
		print "end"
		self.scrollable=False

	def leave_notify(self,widget,e):
		print "leave-end"
		self.scrollable=False

	def motion_notify(self,widget,event):
		if self.scrollable:
			offset = self.start_y - event.y
			self.start_y = offset
			print "offset:",offset
			#force self to scroll 
			new_value = self.initial_bar_y + ( offset )
			print new_value
			self.get_vscrollbar().set_value(new_value)
		return True

	def clear(self):
		print "clearing..."
		children=self.dent_scroll_vbox.get_children()
		for child in children:
			self.dent_scroll_vbox.remove( child )
		#clear the ids
		self.ids = []
