import gtk,gobject
class GroupPage(gtk.VBox,gobject.GObject):
	__gsignals__={
		'group-page-hide': (
			gobject.SIGNAL_RUN_FIRST, gobject.TYPE_NONE,
					   ()
		),
		'join-group' : (
			gobject.SIGNAL_RUN_FIRST,gobject.TYPE_NONE,
				(gobject.TYPE_STRING,gobject.TYPE_BOOLEAN)
			)
	}
	def __init__(self):
		gtk.VBox.__init__(self)
		gobject.GObject.__init__(self)
		self.set_homogeneous(False)
		self.toggle_enabled=False
		#we need a grip of labels
		#self.pack_start( gtk.Label("") )
		self.name_label = gtk.Label()
		self.pack_start(self.name_label,False,False,0)
		
		self.homepage_label = gtk.Label()
		self.pack_start(self.homepage_label,False,False,0)
		
		self.description_label = gtk.Label()
		self.pack_start(self.description_label,False,False,0)
		self.description_label.set_line_wrap(True)
		
		self.location_label = gtk.Label()
		self.pack_start(self.location_label,False,False,0)
		
		#make a checkbutton if we are following
		self.joined_checkbutton = gtk.CheckButton("joined")
		self.joined_checkbutton.connect('toggled', self.joined_toggled)
		self.pack_start(self.joined_checkbutton,False,False,0)
		
		#make a "close" button
		hbox = gtk.HBox(False)
		user_close_button=gtk.Button("Close")
		hbox.pack_start(user_close_button,False,False,0)
		user_close_button.connect("clicked",self.close)
		self.pack_end(hbox,False,False,0)
		
	def set_group_data(self,data):
		self.group_name = data['fullname']
		self.name_label.set_text("%s" %(data['fullname']) )
		if data['location']!=None:
			self.location_label.set_text("%s" %(data['location']) )
			self.location_label.show()
		else:
			self.location_label.hide_all()
			
		if data['description']!=None:
			self.description_label.set_text("%s" %(data['description']) )
			self.description_label.show()
		else:
			self.description_label.hide_all()
		
		if data['homepage']!=None:
			try:
				self.homepage_label.set_markup('<a href="%(homepage)s">%(homepage)s</a>' % ({'homepage':data['homepage']}) )
			except:
				self.homepage_label.set_text("%s" %(data['homepage']) )
			self.homepage_label.show()
		else:
			self.homepage_label.hide_all()
			
	def set_is_member(self,bool):
		self.toggle_enabled=False
		self.is_joined=bool
		self.joined_checkbutton.set_active( bool )
		self.toggle_enabled=True
		
	def clear(self):
		children=self.get_children()
		for child in children:
			self.remove( child )
	
	def joined_toggled(self,widget):
		if self.toggle_enabled:
			self.new_is_joined = self.joined_checkbutton.get_active()
			self.emit('join-group',self.group_name,self.new_is_joined)
		
	def close(self,button):
		self.emit('group-page-hide')
