import gtk,gobject
class UserPage(gtk.VBox,gobject.GObject):
	__gsignals__={
		'user-page-hide': (
			gobject.SIGNAL_RUN_FIRST, gobject.TYPE_NONE,
					   ()
		),
		'follow-user' : (
			gobject.SIGNAL_RUN_FIRST,gobject.TYPE_NONE,
				(gobject.TYPE_STRING,gobject.TYPE_BOOLEAN)
			)
	}
	def __init__(self):
		gtk.VBox.__init__(self)
		gobject.GObject.__init__(self)
		self.set_homogeneous(False)
		self.toggle_enabled=False
		#we need a grip of labels
		#self.pack_start( gtk.Label("") )
		self.name_label = gtk.Label()
		self.pack_start(self.name_label,False,False,0)
		
		self.description_label = gtk.Label()
		self.pack_start(self.description_label,False,False,0)
		self.description_label.set_line_wrap(True)
		
		self.location_label = gtk.Label()
		self.pack_start(self.location_label,False,False,0)
		
		#make a checkbutton if we are following
		self.following_checkbutton = gtk.CheckButton("Following")
		self.following_checkbutton.connect('toggled', self.following_toggled)
		self.pack_start(self.following_checkbutton,False,False,0)
		
		#make a "close" button
		hbox = gtk.HBox(False)
		user_close_button=gtk.Button("Close")
		hbox.pack_start(user_close_button,False,False,0)
		user_close_button.connect("clicked",self.close)
		self.pack_end(hbox,False,False,0)
		
	def set_user_data(self,data):
		self.screen_name = data['screen_name']
		self.name_label.set_text("%s (%s)" %(data['name'],data['screen_name']) )
		if data['location']!=None:
			self.location_label.set_text("%s" %(data['location']) )
			self.location_label.show()
		else:
			self.location_label.hide()
			
		self.description_label.set_text("%s" %(data['description']) )
		
	def set_is_friend(self,bool):
		self.toggle_enabled=False
		self.is_friend=bool
		self.following_checkbutton.set_active( bool )
		self.toggle_enabled=True
		
	def following_toggled(self,widget):
		if self.toggle_enabled:
			self.new_is_friend = self.following_checkbutton.get_active()
			self.emit('follow-user',self.screen_name,self.new_is_friend)
		
	def close(self,button):
		self.emit('user-page-hide')
