from xml.dom.minidom import parse, parseString
import datetime
import time
class XMLProcessor():
	def __init__(self):
		pass
	
	def get_statuses(self,text,is_direct=False):
		dom = parseString(text)
		if is_direct:
			tag="direct_message"
		else:
			tag="status"
		return dom.getElementsByTagName(tag)

	def get_dom(self,text):
		dom = parseString(text)
		return dom
	
	def get_user_info(self,text):
		dom = parseString(text)
		data = {}
		data['name'] = self.get_node_text(dom,'name')
		data['screen_name'] = self.get_node_text(dom,'screen_name')
		data['location'] = self.get_node_text(dom,'location')
		data['description'] = self.get_node_text(dom,'description')
		data['url']=self.get_node_text(dom,'url')
		return data
		
	def get_group_info(self,text):
		dom = parseString(text)
		data = {}
		data['id'] = self.get_node_text(dom,'id')
		data['fullname'] = self.get_node_text(dom,'fullname')
		data['location'] = self.get_node_text(dom,'location')
		data['description'] = self.get_node_text(dom,'description')
		#data['url']=self.get_node_text(dom,'url')
		data['homepage']=self.get_node_text(dom,'homepage')
		return data
	
	def get_user_is_friend(self,text):
		dom = parseString(text)
		f = self.get_node_text(dom,'friends')
		if f=="true":
			friends = True
		else:
			friends = False
		return friends
	
	def get_user_is_member(self,text):
		dom = parseString(text)
		m = self.get_node_text(dom,'is_member')
		if m=="true":
			member = True
		else:
			member = False
		return member
	
	
	def get_node_text(self,node,tag):
		try:
			text=node.getElementsByTagName(tag)[0].firstChild.data
		except:
			text=None
		return text

	def xmlentities(self,data):
		data = data.replace("&", "&amp;")
		data = data.replace("<", "&lt;")
		data = data.replace("\"", "&quot;")
		data = data.replace(">", "&gt;")
		return data

	def get_dent_data(self,status):
		#make dict to hold the data
		dict={}
		dict['status_id'] = int(self.get_node_text(status,"id") )
		dict['name'] = self.get_node_text(status,"name")
		dict['screen_name']=self.get_node_text(status,"screen_name")
		dict['text']=self.get_node_text(status,"text")
		dict['in_reply_to_screen_name']=self.get_node_text(status,"in_reply_to_screen_name")
		dict['profile_image_url']=self.get_node_text(status,"profile_image_url")
		created=self.get_node_text(status,'created_at')
		''' Wed May 26 01:27:08 +0000 2010 '''
		t = time.mktime(time.strptime(created,"%a %b %d %H:%M:%S +0000 %Y") )
		t-= ( time.altzone)
		lt = time.localtime(t)
		#what about DST?
		#format the time		
		dict['time']=time.asctime(lt)


		#process the in reply to
		in_reply_to_id_str=self.get_node_text(status,"in_reply_to_status_id")
		if in_reply_to_id_str!=None:
			in_reply_to_id=int(in_reply_to_id_str)
		else:
			in_reply_to_id=None
		dict['in_reply_to_id']=in_reply_to_id
		return dict
