#!/usr/bin/env python
import gtk,gobject
import sys, os
from xml.dom.minidom import parse, parseString
import re
import time
#what are the custom classes that I need?
from Communicator import Communicator
from Configuration import Configuration
from XMLProcessor import XMLProcessor
from ImageCache import ImageCache
import MainWindow
global app_name
app_name = "heybuddy"
highest_id={MainWindow.DENT:0,MainWindow.MENTION:0,MainWindow.DIRECT:0}
class application :
	def __init__(self):
		#init threading
		gobject.threads_init()
		#keep track of the direct_message requests
		self.last_direct_message_time=0
		self.waiting_requests=0
		self.is_first_dents = True
		asset_dir = "assets"
		heybuddy_dir = os.path.dirname( os.path.realpath( __file__ ) )
		self.default_icon_path = os.path.join(heybuddy_dir,asset_dir,"icon.png")
		self.networking_icon_path = os.path.join(heybuddy_dir,asset_dir,"icon1.png")
		self.conf = Configuration(app_name)
		self.xmlprocessor = XMLProcessor()
		#create a regex to replace parts of a dent
		self.regex_tag = re.compile("(^| )(#[A-z0-9_]+)")
		self.regex_group = re.compile("(^| )(![A-z0-9_]+)")
		self.regex_user=re.compile("(^| )(@[A-z0-9_]+)")
		self.regex_url=re.compile("(https?://([-\w\.]+)+(:\d+)?(/([\w/_\-\+\.\#]*(\?\S+)?)?)?)")
		#build the GUI 
		self.mainwindow=MainWindow.MainWindow(app_name)
		try:
			self.mainwindow.set_icon_from_file(self.default_icon_path)
		except:
			print "failed to load %s" % (icon_path)
		self.mainwindow.connect("destroy", self.quit )
		self.mainwindow.connect("update-status",self.update_status)
		self.mainwindow.connect("update-account",self.update_account)
		self.mainwindow.connect("get-conversation",self.get_conversation)
		self.mainwindow.connect("show-user",self.get_user_info)
		self.mainwindow.connect("show-group",self.get_group_info)
		self.mainwindow.connect("notebook-page-change",self.page_change)
		self.mainwindow.connect('follow-user',self.follow_user)
		self.mainwindow.connect('join-group',self.join_group)
		#create the communicator
		self.comm = Communicator(app_name)
		self.comm.connect('statusesXML',self.process_statusesXML,MainWindow.DENT)
		self.comm.connect('mentionsXML',self.process_statusesXML,MainWindow.MENTION)
		self.comm.connect('group-statusesXML',self.process_statusesXML,MainWindow.GROUP)
		self.comm.connect('user-statusesXML',self.process_statusesXML,MainWindow.USER)
		self.comm.connect('direct_messagesXML',self.process_statusesXML,MainWindow.DIRECT,True)
		self.comm.connect('conversationXML',self.process_conversationXML)
		self.comm.connect('userXML',self.process_userXML)
		self.comm.connect('groupXML',self.process_groupXML)
		self.comm.connect('new-statusXML',self.process_new_statusXML)
		self.comm.connect('user_is_friendXML',self.process_user_is_friendXML)
		self.comm.connect('user_is_memberXML',self.process_user_is_memberXML)
		self.comm.connect('friendshipXML',self.process_friendshipXML)
		self.comm.connect('exception-caught',self.communication_exception)
		self.comm.connect('dent-image',self.process_dent_image)
		#create an image cacher thingy
		self.imagecache = ImageCache()
		self.imagecache.connect('get-dent-image', self.get_dent_image)
		
	def update_account(self,widget,n,p):
		if n!=self.conf.name() or p!=self.conf.password():
			#TODO:check if these are valid
			#self.comm.check_validity(n,p)
			self.valid_account_info(widget,n,p)
			
	def increment_requests(self):
		self.waiting_requests+=1
		if self.waiting_requests==1:
			try:
				self.mainwindow.set_icon_from_file(self.networking_icon_path)
			except:
				print "failed to load %s" % (self.networking_icon_path)
	def decrement_requests(self):
		self.waiting_requests-=1
		if self.waiting_requests==0:
			try:
				self.mainwindow.set_icon_from_file(self.default_icon_path)
			except:
				print "failed to load %s" % (self.default_icon_path)
		if self.waiting_requests<0:
			self.waiting_requests=0
	
	def valid_account_info(self,object,n,p):
		self.conf.name( n )
		self.conf.password( p )
		self.conf.save()
		#update the comm
		self.comm.set_name_and_password( n,p )
		#switch to the dents page
		self.mainwindow.set_notebook_page(MainWindow.DENT) 
		self.get_statuses()

	def get_statuses(self):
		self.increment_requests()
		self.comm.get_statuses(highest_id[MainWindow.DENT])
	
	def get_mentions(self):
		self.increment_requests()
		self.comm.get_mentions(highest_id[MainWindow.MENTION])	
	
	def get_direct_messages(self):
		now = time.time()
		#has it been 3 minutes since the last request?
		if now-(3*60) > self.last_direct_message_time:
			self.increment_requests()
			self.comm.get_direct_messages(highest_id[MainWindow.DIRECT])	
			self.last_direct_message_time=now
	
	def run(self):
		#start the communicator
		self.comm.start()
		self.main_loop = gobject.MainLoop()
		#add a function to the main loop
		gobject.timeout_add(90*1000, self.update_statuses )
		gobject.timeout_add(3*60*1000, self.update_mentions)
		#gobject.timeout_add(10*60*1000, self.update_direct_messages)
		#did the conf read a name and password?
		if( self.conf.name() !="" and self.conf.password()!=""):
			self.comm.set_name_and_password( self.conf.name(),self.conf.password() )
			#add a timout to get dents
			gobject.timeout_add(500,self.get_statuses )
			gobject.timeout_add(600,self.get_mentions )
			#gobject.timeout_add(1000,self.get_direct_messages )
			self.mainwindow.set_notebook_page(MainWindow.MENTION)
			self.mainwindow.set_notebook_page(MainWindow.DENT)
		else:
			#set the focus on the account page; the last page
			self.mainwindow.set_notebook_page(MainWindow.ACCOUNT)
		
		self.mainwindow.run()
		self.main_loop.run()

	def update_statuses(self):
		self.get_statuses()
		return True
	
	def update_mentions(self):
		self.get_mentions()
		return True
	
	def update_direct_messages(self):
		self.get_direct_messages()
		return True
	
	def update_status(self,widget,text,id):
		self.increment_requests()
		#remove newlines from text
		text=text.replace("\n","")
		self.comm.send_update_status(text,id)
		
	def quit(self,widget=None):
		self.main_loop.quit()
		#quit the communicator loop
		self.comm.quit()
	
	def get_dent_image(self,imagecache,image):
		self.comm.get_dent_image(image)
	
	def get_conversation(self,window=None,id=0):
		self.increment_requests()
		self.comm.get_conversation(id)
	
	def get_user_info(self,widget,name):
		self.increment_requests()
		self.comm.get_user_info(name)
		self.increment_requests()
		self.comm.get_user_is_friend(name)
		self.increment_requests()
		self.comm.get_user_statuses(name)
	
	def get_group_info(self,widget,name):
		self.increment_requests()
		self.comm.get_group_info(name)
	
	def follow_user(self,widget,name,bool):
		if bool:
			self.comm.friendship_create(name)
		else:
			self.comm.friendship_destroy(name)
	
	def join_group(self,widget,name,bool):
		if bool:
			self.comm.group_join(name)
		else:
			self.comm.group_leave(name)
	
	def process_friendshipXML(self,widget,text):
		pass
	
	def page_change(self,widget,old_id,new_id):
		if new_id==MainWindow.DIRECT:
			self.get_direct_messages()
	
	def process_userXML(self,comm,text):
		self.decrement_requests()
		data = self.xmlprocessor.get_user_info(text)
		self.mainwindow.display_user(data)
	
	def process_groupXML(self,comm,text):
		self.decrement_requests()
		data = self.xmlprocessor.get_group_info(text)
		#is this user a member of this group
		self.increment_requests()
		self.comm.get_user_is_member(data['id'])
		self.increment_requests()
		self.comm.get_group_statuses(data['id'])
		self.mainwindow.display_group(data)
	
	def process_user_is_friendXML(self,comm,text):
		self.decrement_requests()
		is_friend = self.xmlprocessor.get_user_is_friend(text)
		self.mainwindow.display_user_is_friend( is_friend )
	
	def process_user_is_memberXML(self,comm,text):
		self.decrement_requests()
		is_member = self.xmlprocessor.get_user_is_member(text)
		self.mainwindow.display_user_is_member( is_member )
	
	def process_new_statusXML(self,comm,text):
		#a update status was sent, get all new statuses
		self.update_statuses()
		self.decrement_requests()

	def process_conversationXML(self,object,text):
		self.decrement_requests()
		#get the status
		status = self.xmlprocessor.get_dom(text)
		data = self.xmlprocessor.get_dent_data(status)
		data['markup']=self.markup_dent_text(data['text'])
		#since this is a conversation, we can get rid of the in_reply_to_screen_name
		data['in_reply_to_screen_name']=None
		#tell the mainWindow to add the dent
		self.mainwindow.add_dent(data,MainWindow.CONVERSATION,True)
		if data['in_reply_to_id']!=None:
			#recursively get in_reply_to_ids
			self.get_conversation(id=data['in_reply_to_id'])
		
	def get_dent_time(self,text):
		print text
		
	def markup_dent_text(self,text):
		#process the text to markup
		#xmlencode the string
		text = self.xmlprocessor.xmlentities(text)
		#regex find the highlights
		markup = self.regex_tag.sub(r'\1<b>\2</b>',text)
		#regex find users
		if MainWindow.has_hildon:
			markup = self.regex_group.sub(r'\1<b>\2</b>',markup)
			markup = self.regex_user.sub(r'\1<b>\2</b>',markup)
		else:
			#find urls
			markup = self.regex_url.sub(r'<a href="\1">\1</a>',markup)
			markup = self.regex_user.sub(r'\1<a href="\2">\2</a>',markup)
			markup = self.regex_group.sub(r'\1<a href="\2">\2</a>',markup)
		return markup
	
	def process_statusesXML(self,object,text,target_index,is_direct=False):
		self.decrement_requests()
		#get a list of the statuses
		statuses = self.xmlprocessor.get_statuses(text,is_direct)
		#reverse the statuses list
		statuses.reverse()
		#what is the highest id of the target index?	
		for status in statuses:
			data = self.xmlprocessor.get_dent_data(status)

			if target_index!=None:
				highest_id[target_index]=data['status_id']

			#get the markup
			data['markup'] = self.markup_dent_text(data['text'])
			dent = self.mainwindow.add_dent(data,target_index)
			#get the image for this dent
			self.imagecache.add_image_to_dent(data['profile_image_url'],dent)
			#if the target_index = 0 and not first_dents and not is_conf
			if target_index==MainWindow.DENT and not self.is_first_dents:
				if "@"+self.conf.name() in data['markup']:					
					self.mainwindow.add_dent(data,MainWindow.MENTION)
				
		self.is_first_dents=False
		#get the related images
		self.imagecache.get_images()
	
	def process_dent_image(self,comm,data,name):
		self.imagecache.dent_image_add(data,name)	
		
	def communication_exception(self,communicator,code):
		self.decrement_requests()
		if code=="401": 
			#bad authorization
			self.mainwindow.set_message("Invalid Authorization: Your name or password is incorrect",MainWindow.ERROR_MESSAGE)
			self.mainwindow.set_notebook_page(MainWindow.ACCOUNT)
		elif code == "404":
			print 'not found'
		elif code == "503":
			print 'service unavailable'
		else:
			print 'unknown error: '+code
					
if(__name__=="__main__"):
	a = application()
	a.run()
